// Bjrk Boye Busch - december 2008
using System;
using System.Collections.Generic;
using System.Text;

namespace TokenLibrary
{
    // Hjlpestruktur (DTO) - hvorfor jeg ikke "gider" lave indkapsling og properties p felter
    
    public class RuteToken
    {
        public enum TokenType { ToCifretTal, TreCifretTal, Bynavn, NummerTegn, Kolon, Slut, Fejl };

        public TokenType Typen;     // bestemt form da Type er et C# reserveret ord
        public string Leksem;       // Value
        public RuteToken(TokenType typen, string leksem)
        {
            this.Typen = typen;
            this.Leksem = leksem;
        }


        // Resten med af hensyn til test
        public string  TypenAsText      // af hensyn til testudskrift - lavet som property
        {
            get {
                switch (this.Typen)
                {
                    case TokenType.ToCifretTal: return "ToCifretTal";
                    case TokenType.TreCifretTal: return "TreCifretTal";
                    case TokenType.Bynavn: return "Bynavn";
                    case TokenType.NummerTegn: return "NummerTegn";
                    case TokenType.Kolon: return "Kolon";
                    case TokenType.Slut: return "Slut";
                    case TokenType.Fejl: return "Fejl";
                    default: throw new Exception("Der m vre en type jeg har glemt");      // kan udelades - giver s fejl hvis ingen af ovenstende
                }
            }
        }
        public override string  ToString()      // af hensyn til testudskrift
        {
            return TypenAsText+" leksem<"+this.Leksem+">";
        }
    }
}
