// Bjrk Boye Busch - december 2008
using System;
using System.Collections.Generic;
using System.Text;

namespace ParserTestApplication
{
    class Program
    {
        static void Main(string[] args)
        {
            List<TokenLibrary.RuteToken> tokens = new List<TokenLibrary.RuteToken>();
            tokens.Add(new TokenLibrary.RuteToken(TokenLibrary.RuteToken.TokenType.NummerTegn, "#"));
            tokens.Add(new TokenLibrary.RuteToken(TokenLibrary.RuteToken.TokenType.ToCifretTal, "10"));
            tokens.Add(new TokenLibrary.RuteToken(TokenLibrary.RuteToken.TokenType.Bynavn, "Odense"));
            tokens.Add(new TokenLibrary.RuteToken(TokenLibrary.RuteToken.TokenType.ToCifretTal, "08"));
            tokens.Add(new TokenLibrary.RuteToken(TokenLibrary.RuteToken.TokenType.Kolon, ":"));
            tokens.Add(new TokenLibrary.RuteToken(TokenLibrary.RuteToken.TokenType.ToCifretTal, "30"));
            tokens.Add(new TokenLibrary.RuteToken(TokenLibrary.RuteToken.TokenType.Bynavn, "Otterup"));
            tokens.Add(new TokenLibrary.RuteToken(TokenLibrary.RuteToken.TokenType.ToCifretTal, "08"));
            tokens.Add(new TokenLibrary.RuteToken(TokenLibrary.RuteToken.TokenType.Kolon, ":"));
            tokens.Add(new TokenLibrary.RuteToken(TokenLibrary.RuteToken.TokenType.ToCifretTal, "50"));
            tokens.Add(new TokenLibrary.RuteToken(TokenLibrary.RuteToken.TokenType.Bynavn, "Hasmark"));
            tokens.Add(new TokenLibrary.RuteToken(TokenLibrary.RuteToken.TokenType.ToCifretTal, "09"));
            tokens.Add(new TokenLibrary.RuteToken(TokenLibrary.RuteToken.TokenType.Kolon, ":"));
            tokens.Add(new TokenLibrary.RuteToken(TokenLibrary.RuteToken.TokenType.ToCifretTal, "01"));
            tokens.Add(new TokenLibrary.RuteToken(TokenLibrary.RuteToken.TokenType.Bynavn, "Trres"));
            tokens.Add(new TokenLibrary.RuteToken(TokenLibrary.RuteToken.TokenType.ToCifretTal, "09"));
            tokens.Add(new TokenLibrary.RuteToken(TokenLibrary.RuteToken.TokenType.Kolon, ":"));
            tokens.Add(new TokenLibrary.RuteToken(TokenLibrary.RuteToken.TokenType.ToCifretTal, "15"));

            tokens.Add(new TokenLibrary.RuteToken(TokenLibrary.RuteToken.TokenType.ToCifretTal, "00"));
            tokens.Add(new TokenLibrary.RuteToken(TokenLibrary.RuteToken.TokenType.Bynavn, "ABC"));
            tokens.Add(new TokenLibrary.RuteToken(TokenLibrary.RuteToken.TokenType.NummerTegn, "#"));
            tokens.Add(new TokenLibrary.RuteToken(TokenLibrary.RuteToken.TokenType.TreCifretTal, "100"));

            tokens.Add(new TokenLibrary.RuteToken(TokenLibrary.RuteToken.TokenType.NummerTegn, "#"));
            tokens.Add(new TokenLibrary.RuteToken(TokenLibrary.RuteToken.TokenType.TreCifretTal, "111"));
            tokens.Add(new TokenLibrary.RuteToken(TokenLibrary.RuteToken.TokenType.Bynavn, "Bogense"));
            tokens.Add(new TokenLibrary.RuteToken(TokenLibrary.RuteToken.TokenType.ToCifretTal, "18"));
            tokens.Add(new TokenLibrary.RuteToken(TokenLibrary.RuteToken.TokenType.Kolon, ":"));
            tokens.Add(new TokenLibrary.RuteToken(TokenLibrary.RuteToken.TokenType.ToCifretTal, "30"));
            tokens.Add(new TokenLibrary.RuteToken(TokenLibrary.RuteToken.TokenType.Bynavn, "Hasmark"));
            tokens.Add(new TokenLibrary.RuteToken(TokenLibrary.RuteToken.TokenType.ToCifretTal, "19"));
            tokens.Add(new TokenLibrary.RuteToken(TokenLibrary.RuteToken.TokenType.Kolon, ":"));
            tokens.Add(new TokenLibrary.RuteToken(TokenLibrary.RuteToken.TokenType.ToCifretTal, "15"));

            tokens.Add(new TokenLibrary.RuteToken(TokenLibrary.RuteToken.TokenType.Slut, ""));


            Parser_Regelbaseret.Parser parser = new Parser_Regelbaseret.Parser(tokens);

            if (parser.Parse())
            {
                Console.WriteLine("Parsing afsluttet uden fejl");
                Console.WriteLine("\nGendkendt syntakstr");
                Model_Syntakstr.RegionsKreplan rpl = parser.GetRegionsKreplan();
                rpl.Udskriv();
            }
            else
            {
                Console.WriteLine("Parsing afsluttet med fejl");
                Console.WriteLine("\nGendkendt syntakstr");
                Model_Syntakstr.RegionsKreplan rpl = parser.GetRegionsKreplan();
                rpl.Udskriv();
            }


            Console.ReadLine();
        }
    }
}
